------------------------------------------------------------------------------
--
-- (C) Copyright 2003 - 2007 Novell, Inc.
-- All Rights Reserved.
--
--  Workfile:   ncs.sch
--  Contents:   eDirectory Schema for Novell Cluster Services
--
------------------------------------------------------------------------------
--
-- Common acronyms used in this schema.  Please keep in alphabetical order.
--
-- BCC  - Business Continuance Cluster
-- CRM  - Cluster Resource Manager
-- GIPC - Group Interprocess Communication
-- HMO  - Health Monitor Object
-- NCS  - Novell Cluster Services
--
------------------------------------------------------------------------------

------------------------------------------------------------------------------
-- The following OID ranges are reserved for BCC
-- Attributes: 2 16 840 1 113719 1 67 4 4 xxx
-- Classes: 2 16 840 1 113719 1 67 6 100 - 2 16 840 1 113719 1 67 6 200
------------------------------------------------------------------------------

NCSSchemaExtensions {2 16 840 1 113719 1 67} DEFINITIONS ::=
BEGIN

------------------------------------------------------------------------------
-- NCS Attributes
------------------------------------------------------------------------------

"NCS:GIPC Config" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_STREAM,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 1 1}
}

"NCS:GIPC Node Number" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 1 2}
}

"NCS:GIPC Heartbeat" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 1 3}
}

"NCS:GIPC Tolerance" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 1 4}
}

"NCS:GIPC Master Watchdog" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 1 5}
}

"NCS:GIPC Slave Watchdog" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 1 6}
}

"NCS:GIPC Max Retransmits" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 1 7}
}

"NCS:CRM Quorum" ATTRIBUTE ::=
{
    Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 1}
}

"NCS:CRM Ignore Quorum" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_BOOLEAN,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 2}
}

"NCS:CRM Quorum Timeout" ATTRIBUTE ::=
{
    Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 3}
}

"NCS:CRM Load Script" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_STREAM,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 4}
}

"NCS:CRM Load Timeout" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 5}
}

"NCS:CRM Unload Script" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_STREAM,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 6}
}

"NCS:CRM Unload Timeout" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 7}
}

"NCS:CRM Preferred Nodes" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_OCTET_STRING,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 8}
}

"NCS:CRM Failback Mode" ATTRIBUTE ::=
{
   Operation   ADD,
    SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 9}
}

"NCS:CRM Failover Mode" ATTRIBUTE ::=
{
   Operation   ADD,
    SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 10}
}

"NCS:CRM Resource Priority" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_STREAM,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 11}
}

"NCS:CRM HMO Setting" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 12}
}

"NCS:CRM Monitor Script" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_STREAM,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 13}
}

"NCS:CRM Monitor Timeout" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 14}
}

"NCS:CRM Monitor Frequency" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 15}
}

"NCS:CRM Monitor Max Failures" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 16}
}

"NCS:CRM Monitor Failure Period" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 17}
}

"NCS:CRM Monitor Action" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 2 18}
}

"NCS:Revision" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 1}
}

"NCS:NetWare Cluster" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_DIST_NAME,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 2}
}

"NCS:NCP Server" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_DIST_NAME,
    Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 3}
}

"NCS:Network Address" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_NET_ADDRESS,
    Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 4}
}

"NCS:Volume" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_DIST_NAME,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 5}
}

"NCS:Port Number" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 6}
}

"NCS:Node Isolation Script" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_STREAM,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 7}
}

"NCS:Email Addresses" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_OCTET_STRING,
   Flags       {DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 8}
}

"NCS:Email Filter" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 9}
}

"NCS:Volumes" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_DIST_NAME,
   Flags       {DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 10}
}

"NCS:Load Factor" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_INTEGER,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 11}
}

"NCS:Shared Disk Flag" ATTRIBUTE ::=
{
   Operation   ADD,
   SyntaxID    SYN_BOOLEAN,
   Flags       {DS_SINGLE_VALUED_ATTR, DS_SYNC_IMMEDIATE},
   ASN1ObjID   {2 16 840 1 113719 1 67 4 3 12}
}


------------------------------------------------------------------------------
-- NCS Classes
------------------------------------------------------------------------------

"NCS:NetWare Cluster" OBJECT-CLASS ::=
{
   Operation   ADD,
   Flags       {DS_EFFECTIVE_CLASS, DS_CONTAINER_CLASS},
   SubClassOf  {"TOP"},
   MustContain {"CN"},
   MayContain  {
                    "NCS:Revision",
                    "NCS:Port Number",
               "NCS:Network Address",
                    -- GIPC
                    "NCS:GIPC Config",
                    "NCS:GIPC Heartbeat",
                    "NCS:GIPC Tolerance",
                    "NCS:GIPC Master Watchdog",
                    "NCS:GIPC Slave Watchdog",
                    "NCS:GIPC Max Retransmits",
                    -- CRM
                    "NCS:CRM Quorum",
                    "NCS:CRM Quorum Timeout",
                    "NCS:CRM Load Script",
                    "NCS:CRM Load Timeout",
                    "NCS:CRM Unload Script",
                    "NCS:CRM Unload Timeout"
                },
   NamedBy     {"CN"},
   ContainedBy {"Organization", "Organizational Unit", "domain"},
   ASN1ObjID   {2 16 840 1 113719 1 67 6 1}
}

"NCS:Cluster Resource" OBJECT-CLASS ::=
{
   Operation   ADD,
   Flags       {DS_EFFECTIVE_CLASS},
   SubClassOf  {"TOP"},
   MustContain {"CN"},
   MayContain  {
                    -- CRM
                    "NCS:Revision",
                    "NCS:CRM Ignore Quorum",
                    "NCS:CRM Load Script",
                    "NCS:CRM Load Timeout",
                    "NCS:CRM Unload Script",
                    "NCS:CRM Unload Timeout",
                    "NCS:CRM Preferred Nodes",
                    "NCS:CRM Failback Mode",
                    "NCS:CRM Failover Mode",
            "NCS:CRM Monitor Script",
            "NCS:CRM Monitor Timeout",
            "NCS:CRM Monitor Frequency",
            "NCS:CRM Monitor Max Failures",
            "NCS:CRM Monitor Failure Period",
            "NCS:CRM Monitor Action"
                },
   NamedBy     {"CN"},
   ContainedBy {"NCS:NetWare Cluster","domain"},
   ASN1ObjID   {2 16 840 1 113719 1 67 6 2}
}

"NCS:Resource Template" OBJECT-CLASS ::=
{
   Operation   ADD,
   Flags       {DS_EFFECTIVE_CLASS},
   SubClassOf  {"TOP"},
   MustContain {"CN"},
   MayContain  {
                    -- CRM
                    "NCS:Revision",
                    "NCS:CRM Ignore Quorum",
                    "NCS:CRM Load Script",
                    "NCS:CRM Load Timeout",
                    "NCS:CRM Unload Script",
                    "NCS:CRM Unload Timeout",
                    "NCS:CRM Preferred Nodes",
                    "NCS:CRM Failback Mode",
                    "NCS:CRM Failover Mode",
                    "NCS:CRM Monitor Script",
                    "NCS:CRM Monitor Timeout",
                    "NCS:CRM Monitor Frequency",
                    "NCS:CRM Monitor Max Failures",
                    "NCS:CRM Monitor Failure Period",
                    "NCS:CRM Monitor Action"
                },
   NamedBy     {"CN"},
   ContainedBy {"NCS:NetWare Cluster","domain"},
   ASN1ObjID   {2 16 840 1 113719 1 67 6 3}
}

"NCS:NCP Server" OBJECT-CLASS ::=
{
   Operation   ADD,
   Flags       {DS_EFFECTIVE_CLASS},
   SubClassOf  {"TOP"},
   MustContain {"CN"},
   MayContain  {
                    "NCS:NCP Server",
                    "NCS:Network Address",
                    "NCS:GIPC Node Number",
                    "NCS:CRM Load Script",
                    "NCS:CRM Load Timeout",
                    "NCS:CRM Unload Script",
                    "NCS:CRM Unload Timeout"
                },
   NamedBy     {"CN"},
   ContainedBy {"NCS:NetWare Cluster", "domain"},
   ASN1ObjID   {2 16 840 1 113719 1 67 6 4}
}

"NCS:Volume Resource" OBJECT-CLASS ::=
{
   Operation   ADD,
   Flags       {DS_EFFECTIVE_CLASS},
   SubClassOf  {"TOP"},
   MustContain {"CN"},
   MayContain  {
                    -- CRM
                    "NCS:Revision",
               "NCS:CRM Ignore Quorum",
               "NCS:CRM Load Script",
               "NCS:CRM Load Timeout",
               "NCS:CRM Unload Script",
               "NCS:CRM Unload Timeout",
               "NCS:CRM Preferred Nodes",
               "NCS:CRM Failback Mode",
               "NCS:CRM Failover Mode",
               "NCS:CRM Monitor Script",
               "NCS:CRM Monitor Timeout",
               "NCS:CRM Monitor Frequency",
               "NCS:CRM Monitor Max Failures",
               "NCS:CRM Monitor Failure Period",
               "NCS:CRM Monitor Action",
               -- Backlinks
               "NCS:NCP Server",
               "NCS:Volume"
            },
   NamedBy     {"CN"},
   ContainedBy {"NCS:NetWare Cluster", "domain"},
   ASN1ObjID   {2 16 840 1 113719 1 67 6 5}
}


------------------------------------------------------------------------------
-- Extend Existing NCS Classes
------------------------------------------------------------------------------

"NCS:NetWare Cluster" OBJECT-CLASS ::=
{
   Operation   MODIFY,
   MayContain  {
                        "NCS:CRM Resource Priority",
                        "NCS:Node Isolation Script",
                        "NCS:Email Addresses",
                        "NCS:Email Filter",
                        "Network Address",
                        "NCS:CRM HMO Setting",
                        "NCS:Shared Disk Flag"
                    }
}

"NCP Server" OBJECT-CLASS ::=
{
   Operation   MODIFY,
   MayContain  {
                        "NCS:NetWare Cluster",
                        "NCS:Volume",
                        "NCS:Volumes",
                        "NCS:Load Factor"
               }
}

"NCS:Cluster Resource" OBJECT-CLASS ::=
{
   Operation   MODIFY,
   MayContain  {
                        "NCS:Load Factor"
               }
}

"NCS:Resource Template" OBJECT-CLASS ::=
{
   Operation   MODIFY,
   MayContain  {
                        "NCS:Load Factor"
               }
}

"NCS:Volume Resource" OBJECT-CLASS ::=
{
   Operation   MODIFY,
    MayContain  {
                        "NCS:Volumes",
                        "NCS:Load Factor"
                     }
}

"NCS:NCP Server" OBJECT-CLASS ::=
{
   Operation   MODIFY,
    MayContain  {
                        "NCS:Node Isolation Script"
                }
}

END

